#! /usr/bin/env bash

GLOVE="../../../../GloVe/"

if [ "$#" -ne 3 ]; then
    echo "USAGE : $0 input.conllu embeddingsSize output.w2v"
    exit 1
fi

CURDIR="$(pwd)"
cd $GLOVE && make && cd $CURDIR \
&& udpipe --output=horizontal none $1 > in.text \
&& $GLOVE"build/vocab_count" -min-count 2 < in.text > vocab.txt \
&& $GLOVE"build/cooccur" -symmetric 0 -window-size 10 -vocab-file vocab.txt -memory 8.0 -overflow-file tempoverflow < in.text > cooccurrences.bin \
&& $GLOVE"build/shuffle" -memory 8.0 -seed 100 < cooccurrences.bin > cooccurrence.shuf.bin \
&& $GLOVE"build/glove" -iter 50 -save_gradsq 0 -write-header 1 -input-file cooccurrence.shuf.bin -vocab-file vocab.txt -save-file out -gradsq-file gradsq -vector-size $2 -seed 100 -threads 1 -alpha 0.75 -x-max 100.0 -eta 0.05 -binary 0 -model 1 \
&& mv out.txt $3

rm in.text 2> /dev/null
rm vocab.txt 2> /dev/null
rm cooccurrences.bin 2> /dev/null
rm cooccurrence.shuf.bin 2> /dev/null
rm overflow_*\.bin 2> /dev/null

exit 0
